Index: /NEMO/branches/2018/dev_r9947_SI3_advection/cfgs/SPITZ12/EXPREF/namelist_ice_cfg
===================================================================
--- /NEMO/branches/2018/dev_r9947_SI3_advection/cfgs/SPITZ12/EXPREF/namelist_ice_cfg	(revision 10410)
+++ /NEMO/branches/2018/dev_r9947_SI3_advection/cfgs/SPITZ12/EXPREF/namelist_ice_cfg	(revision 10411)
@@ -35,5 +35,4 @@
 &namdyn         !   Ice dynamics
 !------------------------------------------------------------------------------
-   ln_landfast      = .false.         !  landfast ice parameterization (T or F)
 /
 !------------------------------------------------------------------------------
Index: /NEMO/branches/2018/dev_r9947_SI3_advection/src/ICE/icedyn.F90
===================================================================
--- /NEMO/branches/2018/dev_r9947_SI3_advection/src/ICE/icedyn.F90	(revision 10410)
+++ /NEMO/branches/2018/dev_r9947_SI3_advection/src/ICE/icedyn.F90	(revision 10411)
@@ -218,5 +218,5 @@
                   !                               ! -- check h_i -- !
                   ! if h_i is larger than the surrounding 9 pts => reduce h_i and increase a_i
-                  zhi = v_i (ji,jj,jl) / a_i(ji,jj,jl)
+                  zhi = v_i(ji,jj,jl) / a_i(ji,jj,jl)
 !!clem                  zdv = v_i(ji,jj,jl) - v_i_b(ji,jj,jl)  
 !!clem                  IF ( ( zdv >  0.0 .AND. zh > phmax(ji,jj,jl) .AND. at_i_b(ji,jj) < 0.80 ) .OR. &
@@ -228,5 +228,5 @@
                   !                               ! -- check h_s -- !
                   ! if h_s is larger than the surrounding 9 pts => put the snow excess in the ocean
-                  zhs = v_s (ji,jj,jl) / a_i(ji,jj,jl)
+                  zhs = v_s(ji,jj,jl) / a_i(ji,jj,jl)
                   IF( v_s(ji,jj,jl) > 0._wp .AND. zhs > phs_max(ji,jj,jl) .AND. a_i(ji,jj,jl) < 0.15 ) THEN
                      zfra = a_i(ji,jj,jl) * phs_max(ji,jj,jl) / MAX( v_s(ji,jj,jl), epsi20 )
Index: /NEMO/branches/2018/dev_r9947_SI3_advection/src/ICE/icedyn_adv_umx.F90
===================================================================
--- /NEMO/branches/2018/dev_r9947_SI3_advection/src/ICE/icedyn_adv_umx.F90	(revision 10410)
+++ /NEMO/branches/2018/dev_r9947_SI3_advection/src/ICE/icedyn_adv_umx.F90	(revision 10411)
@@ -138,5 +138,5 @@
       ELSE                    ;   icycle = 1 
       ENDIF
-
+      
       zdt = rdt_ice / REAL(icycle)
 
@@ -161,7 +161,8 @@
 
       IF(.NOT. ALLOCATED(z1_ai))       ALLOCATE(z1_ai(jpi,jpj))
-      IF(.NOT. ALLOCATED(amaxu))       ALLOCATE(amaxu (jpi,jpj))
-      IF(.NOT. ALLOCATED(amaxv))       ALLOCATE(amaxv (jpi,jpj))
-
+      IF( ll_zeroup2 ) THEN
+         IF(.NOT. ALLOCATED(amaxu))       ALLOCATE(amaxu (jpi,jpj))
+         IF(.NOT. ALLOCATED(amaxv))       ALLOCATE(amaxv (jpi,jpj))
+      ENDIF
       !---------------!
       !== advection ==!
@@ -365,8 +366,8 @@
                         &         * tmask(ji,jj,1)
                   ENDIF
-                  IF( ji==26 .AND. jj==86) THEN
-                     WRITE(numout,*) '************************'
-                     WRITE(numout,*) 'zpt upstream',zpt(ji,jj)
-                  ENDIF
+!!                  IF( ji==26 .AND. jj==86) THEN
+!!                     WRITE(numout,*) '************************'
+!!                     WRITE(numout,*) 'zpt upstream',zpt(ji,jj)
+!!                  ENDIF
                END DO
             END DO
@@ -412,8 +413,8 @@
                         &         * tmask(ji,jj,1)
                   ENDIF
-                  IF( ji==26 .AND. jj==86) THEN
-                     WRITE(numout,*) '************************'
-                     WRITE(numout,*) 'zpt upstream',zpt(ji,jj)
-                  ENDIF
+!!                  IF( ji==26 .AND. jj==86) THEN
+!!                     WRITE(numout,*) '************************'
+!!                     WRITE(numout,*) 'zpt upstream',zpt(ji,jj)
+!!                  ENDIF
                 END DO
             END DO
@@ -462,8 +463,8 @@
                zt_ups(ji,jj) = ( ptc(ji,jj) + pdt * ztra ) * tmask(ji,jj,1)
             ENDIF
-            IF( ji==26 .AND. jj==86) THEN
-               WRITE(numout,*) '**************************'
-               WRITE(numout,*) 'zt upstream',zt_ups(ji,jj)
-            ENDIF
+!!            IF( ji==26 .AND. jj==86) THEN
+!!               WRITE(numout,*) '**************************'
+!!               WRITE(numout,*) 'zt upstream',zt_ups(ji,jj)
+!!            ENDIF
          END DO
       END DO
@@ -506,7 +507,7 @@
                IF( pt(ji,jj) < 0._wp .AND. pt(ji,jj) >= -epsi20 )   pt(ji,jj) = 0._wp
                
-               IF( ji==26 .AND. jj==86) THEN
-                  WRITE(numout,*) 'zt high order',pt(ji,jj)
-               ENDIF
+!!               IF( ji==26 .AND. jj==86) THEN
+!!                  WRITE(numout,*) 'zt high order',pt(ji,jj)
+!!               ENDIF
             END DO
          END DO
@@ -590,7 +591,7 @@
                ptc(ji,jj) = ( ptc(ji,jj) + ztra ) * tmask(ji,jj,1)
                              
-               IF( ji==26 .AND. jj==86) THEN
-                  WRITE(numout,*) 'ztc high order',ptc(ji,jj)
-               ENDIF
+!!               IF( ji==26 .AND. jj==86) THEN
+!!                  WRITE(numout,*) 'ztc high order',ptc(ji,jj)
+!!               ENDIF
                
             END DO
@@ -1265,11 +1266,11 @@
                   WRITE(numout,*) '*** 1 negative high order zzt ***',ji,jj,zzt(ji,jj)
                ENDIF
-               IF( ji==26 .AND. jj==86) THEN
-                  WRITE(numout,*) 'zzt high order',zzt(ji,jj)
-                  WRITE(numout,*) 'pfu_ho',(pfu_ho(ji,jj)) * r1_e1e2t(ji,jj) * pdt
-                  WRITE(numout,*) 'pfv_ho',(pfv_ho(ji,jj)) * r1_e1e2t(ji,jj) * pdt
-                  WRITE(numout,*) 'pfu_hom1',(pfu_ho(ji-1,jj)) * r1_e1e2t(ji,jj) * pdt
-                  WRITE(numout,*) 'pfv_hom1',(pfv_ho(ji,jj-1)) * r1_e1e2t(ji,jj) * pdt
-               ENDIF
+!!               IF( ji==26 .AND. jj==86) THEN
+!!                  WRITE(numout,*) 'zzt high order',zzt(ji,jj)
+!!                  WRITE(numout,*) 'pfu_ho',(pfu_ho(ji,jj)) * r1_e1e2t(ji,jj) * pdt
+!!                  WRITE(numout,*) 'pfv_ho',(pfv_ho(ji,jj)) * r1_e1e2t(ji,jj) * pdt
+!!                  WRITE(numout,*) 'pfu_hom1',(pfu_ho(ji-1,jj)) * r1_e1e2t(ji,jj) * pdt
+!!                  WRITE(numout,*) 'pfv_hom1',(pfv_ho(ji,jj-1)) * r1_e1e2t(ji,jj) * pdt
+!!               ENDIF
                IF( ll_gurvan ) THEN
                   zzt(ji,jj) = ( pt(ji,jj) - ( pfu_ho(ji,jj) - pfu_ho(ji-1,jj) ) * pdt * r1_e1e2t(ji,jj)  &
@@ -1462,30 +1463,30 @@
             !
 
-            IF( ji==26 .AND. jj==86) THEN
-               WRITE(numout,*) '-----------------'
-               WRITE(numout,*) 'zpos',zpos,zpos2
-               WRITE(numout,*) 'zneg',zneg,zneg2
-               WRITE(numout,*) 'puc/pu',ABS(puc(ji,jj))/MAX(epsi20, ABS(pu(ji,jj)))
-               WRITE(numout,*) 'pvc/pv',ABS(pvc(ji,jj))/MAX(epsi20, ABS(pv(ji,jj)))
-               WRITE(numout,*) 'pucm1/pu',ABS(puc(ji-1,jj))/MAX(epsi20, ABS(pu(ji-1,jj)))
-               WRITE(numout,*) 'pvcm1/pv',ABS(pvc(ji,jj-1))/MAX(epsi20, ABS(pv(ji,jj-1)))
-               WRITE(numout,*) 'pfu_ho',(pfu_ho(ji,jj)+pfu_low(ji,jj)) * r1_e1e2t(ji,jj) * pdt
-               WRITE(numout,*) 'pfv_ho',(pfv_ho(ji,jj)+pfv_low(ji,jj)) * r1_e1e2t(ji,jj) * pdt
-               WRITE(numout,*) 'pfu_hom1',(pfu_ho(ji-1,jj)+pfu_low(ji-1,jj)) * r1_e1e2t(ji,jj) * pdt
-               WRITE(numout,*) 'pfv_hom1',(pfv_ho(ji,jj-1)+pfv_low(ji,jj-1)) * r1_e1e2t(ji,jj) * pdt
-               WRITE(numout,*) 'pfu_low',pfu_low(ji,jj) * r1_e1e2t(ji,jj) * pdt
-               WRITE(numout,*) 'pfv_low',pfv_low(ji,jj) * r1_e1e2t(ji,jj) * pdt
-               WRITE(numout,*) 'pfu_lowm1',pfu_low(ji-1,jj) * r1_e1e2t(ji,jj) * pdt
-               WRITE(numout,*) 'pfv_lowm1',pfv_low(ji,jj-1) * r1_e1e2t(ji,jj) * pdt
-               
-               WRITE(numout,*) 'pt',pt(ji,jj)
-               WRITE(numout,*) 'ptim1',pt(ji-1,jj)
-               WRITE(numout,*) 'ptjm1',pt(ji,jj-1)
-               WRITE(numout,*) 'pt_low',pt_low(ji,jj)
-               WRITE(numout,*) 'zbetup',zbetup(ji,jj)
-               WRITE(numout,*) 'zbetdo',zbetdo(ji,jj)
-               WRITE(numout,*) 'zup',zup
-               WRITE(numout,*) 'zdo',zdo
-            ENDIF
+!!            IF( ji==26 .AND. jj==86) THEN
+!               WRITE(numout,*) '-----------------'
+!               WRITE(numout,*) 'zpos',zpos,zpos2
+!               WRITE(numout,*) 'zneg',zneg,zneg2
+!               WRITE(numout,*) 'puc/pu',ABS(puc(ji,jj))/MAX(epsi20, ABS(pu(ji,jj)))
+!               WRITE(numout,*) 'pvc/pv',ABS(pvc(ji,jj))/MAX(epsi20, ABS(pv(ji,jj)))
+!               WRITE(numout,*) 'pucm1/pu',ABS(puc(ji-1,jj))/MAX(epsi20, ABS(pu(ji-1,jj)))
+!               WRITE(numout,*) 'pvcm1/pv',ABS(pvc(ji,jj-1))/MAX(epsi20, ABS(pv(ji,jj-1)))
+!               WRITE(numout,*) 'pfu_ho',(pfu_ho(ji,jj)+pfu_low(ji,jj)) * r1_e1e2t(ji,jj) * pdt
+!               WRITE(numout,*) 'pfv_ho',(pfv_ho(ji,jj)+pfv_low(ji,jj)) * r1_e1e2t(ji,jj) * pdt
+!               WRITE(numout,*) 'pfu_hom1',(pfu_ho(ji-1,jj)+pfu_low(ji-1,jj)) * r1_e1e2t(ji,jj) * pdt
+!               WRITE(numout,*) 'pfv_hom1',(pfv_ho(ji,jj-1)+pfv_low(ji,jj-1)) * r1_e1e2t(ji,jj) * pdt
+!               WRITE(numout,*) 'pfu_low',pfu_low(ji,jj) * r1_e1e2t(ji,jj) * pdt
+!               WRITE(numout,*) 'pfv_low',pfv_low(ji,jj) * r1_e1e2t(ji,jj) * pdt
+!               WRITE(numout,*) 'pfu_lowm1',pfu_low(ji-1,jj) * r1_e1e2t(ji,jj) * pdt
+!               WRITE(numout,*) 'pfv_lowm1',pfv_low(ji,jj-1) * r1_e1e2t(ji,jj) * pdt
+!               
+!               WRITE(numout,*) 'pt',pt(ji,jj)
+!               WRITE(numout,*) 'ptim1',pt(ji-1,jj)
+!               WRITE(numout,*) 'ptjm1',pt(ji,jj-1)
+!               WRITE(numout,*) 'pt_low',pt_low(ji,jj)
+!               WRITE(numout,*) 'zbetup',zbetup(ji,jj)
+!               WRITE(numout,*) 'zbetdo',zbetdo(ji,jj)
+!               WRITE(numout,*) 'zup',zup
+!               WRITE(numout,*) 'zdo',zdo
+!            ENDIF
             !
          END DO
@@ -1506,9 +1507,9 @@
             pfu_ho(ji,jj) = pfu_ho(ji,jj) * zcoef + pfu_low(ji,jj)
 
-            IF( ji==26 .AND. jj==86) THEN
-               WRITE(numout,*) 'coefU',zcoef
-               WRITE(numout,*) 'pfu_ho',(pfu_ho(ji,jj)) * r1_e1e2t(ji,jj) * pdt
-               WRITE(numout,*) 'pfu_hom1',(pfu_ho(ji-1,jj)) * r1_e1e2t(ji,jj) * pdt
-            ENDIF
+!!            IF( ji==26 .AND. jj==86) THEN
+!!               WRITE(numout,*) 'coefU',zcoef
+!!               WRITE(numout,*) 'pfu_ho',(pfu_ho(ji,jj)) * r1_e1e2t(ji,jj) * pdt
+!!               WRITE(numout,*) 'pfu_hom1',(pfu_ho(ji-1,jj)) * r1_e1e2t(ji,jj) * pdt
+!!            ENDIF
 
          END DO
@@ -1525,9 +1526,9 @@
             pfv_ho(ji,jj) = pfv_ho(ji,jj) * zcoef + pfv_low(ji,jj)
 
-            IF( ji==26 .AND. jj==86) THEN
-               WRITE(numout,*) 'coefV',zcoef
-               WRITE(numout,*) 'pfv_ho',(pfv_ho(ji,jj)) * r1_e1e2t(ji,jj) * pdt
-               WRITE(numout,*) 'pfv_hom1',(pfv_ho(ji,jj-1)) * r1_e1e2t(ji,jj) * pdt
-            ENDIF
+!!            IF( ji==26 .AND. jj==86) THEN
+!!               WRITE(numout,*) 'coefV',zcoef
+!!               WRITE(numout,*) 'pfv_ho',(pfv_ho(ji,jj)) * r1_e1e2t(ji,jj) * pdt
+!!               WRITE(numout,*) 'pfv_hom1',(pfv_ho(ji,jj-1)) * r1_e1e2t(ji,jj) * pdt
+!!            ENDIF
          END DO
       END DO
Index: /NEMO/branches/2018/dev_r9947_SI3_advection/src/ICE/icedyn_rdgrft.F90
===================================================================
--- /NEMO/branches/2018/dev_r9947_SI3_advection/src/ICE/icedyn_rdgrft.F90	(revision 10410)
+++ /NEMO/branches/2018/dev_r9947_SI3_advection/src/ICE/icedyn_rdgrft.F90	(revision 10411)
@@ -192,5 +192,5 @@
             ! divergence given by the advection scheme
             !   (which may not be equal to divu as computed from the velocity field)
-            IF( ln_adv_Pra ) THEN
+            IF    ( ln_adv_Pra ) THEN
                zdivu_adv(ji) = ( 1._wp - ato_i_1d(ji) - SUM( a_i_2d(ji,:) ) ) * r1_rdtice
             ELSEIF( ln_adv_UMx ) THEN
Index: /NEMO/branches/2018/dev_r9947_SI3_advection/src/ICE/icevar.F90
===================================================================
--- /NEMO/branches/2018/dev_r9947_SI3_advection/src/ICE/icevar.F90	(revision 10410)
+++ /NEMO/branches/2018/dev_r9947_SI3_advection/src/ICE/icevar.F90	(revision 10411)
@@ -555,4 +555,54 @@
       !!-------------------------------------------------------------------
       !
+      !
+      DO jl = 1, jpl       !==  loop over the categories  ==!
+         !
+         !----------------------------------------
+         ! zap ice energy and send it to the ocean
+         !----------------------------------------
+         DO jk = 1, nlay_i
+            DO jj = 1 , jpj
+               DO ji = 1 , jpi
+                  IF( pe_i(ji,jj,jk,jl) < 0._wp .OR. pa_i(ji,jj,jl) < 0._wp ) THEN
+                     hfx_res(ji,jj)   = hfx_res(ji,jj) - pe_i(ji,jj,jk,jl) * r1_rdtice ! W.m-2 <0
+                     pe_i(ji,jj,jk,jl) = 0._wp
+                  ENDIF
+               END DO
+            END DO
+         END DO
+         !
+         DO jk = 1, nlay_s
+            DO jj = 1 , jpj
+               DO ji = 1 , jpi
+                  IF( pe_s(ji,jj,jk,jl) < 0._wp .OR. pa_i(ji,jj,jl) < 0._wp ) THEN
+                     hfx_res(ji,jj)   = hfx_res(ji,jj) - pe_s(ji,jj,jk,jl) * r1_rdtice ! W.m-2 <0
+                     pe_s(ji,jj,jk,jl) = 0._wp
+                  ENDIF
+               END DO
+            END DO
+         END DO
+         !
+         !-----------------------------------------------------
+         ! zap ice and snow volume, add water and salt to ocean
+         !-----------------------------------------------------
+         DO jj = 1 , jpj
+            DO ji = 1 , jpi
+               IF( pv_i(ji,jj,jl) < 0._wp .OR. pa_i(ji,jj,jl) < 0._wp ) THEN
+                  wfx_res(ji,jj)    = wfx_res(ji,jj) + pv_i (ji,jj,jl) * rhoi * r1_rdtice
+                  pv_i   (ji,jj,jl) = 0._wp
+               ENDIF
+               IF( pv_s(ji,jj,jl) < 0._wp .OR. pa_i(ji,jj,jl) < 0._wp ) THEN
+                  wfx_res(ji,jj)    = wfx_res(ji,jj) + pv_s (ji,jj,jl) * rhos * r1_rdtice
+                  pv_s   (ji,jj,jl) = 0._wp
+               ENDIF
+               IF( psv_i(ji,jj,jl) < 0._wp .OR. pa_i(ji,jj,jl) < 0._wp ) THEN
+                  sfx_res(ji,jj)    = sfx_res(ji,jj) + psv_i(ji,jj,jl) * rhoi * r1_rdtice
+                  psv_i  (ji,jj,jl) = 0._wp
+               ENDIF
+            END DO
+         END DO
+         !
+      END DO 
+      !
       WHERE( pato_i(:,:)   < 0._wp )   pato_i(:,:)   = 0._wp
       WHERE( poa_i (:,:,:) < 0._wp )   poa_i (:,:,:) = 0._wp
@@ -561,53 +611,4 @@
       WHERE( pv_ip (:,:,:) < 0._wp )   pv_ip (:,:,:) = 0._wp ! in theory one should change wfx_pnd(-) and wfx_sum(+)
       !                                                        but it does not change conservation, so keep it this way is ok
-      !
-      DO jl = 1, jpl       !==  loop over the categories  ==!
-         !
-         !----------------------------------------
-         ! zap ice energy and send it to the ocean
-         !----------------------------------------
-         DO jk = 1, nlay_i
-            DO jj = 1 , jpj
-               DO ji = 1 , jpi
-                  IF( pe_i(ji,jj,jk,jl) < 0._wp ) THEN
-                     hfx_res(ji,jj)   = hfx_res(ji,jj) - pe_i(ji,jj,jk,jl) * r1_rdtice ! W.m-2 <0
-                     pe_i(ji,jj,jk,jl) = 0._wp
-                  ENDIF
-               END DO
-            END DO
-         END DO
-         !
-         DO jk = 1, nlay_s
-            DO jj = 1 , jpj
-               DO ji = 1 , jpi
-                  IF( pe_s(ji,jj,jk,jl) < 0._wp ) THEN
-                     hfx_res(ji,jj)   = hfx_res(ji,jj) - pe_s(ji,jj,jk,jl) * r1_rdtice ! W.m-2 <0
-                     pe_s(ji,jj,jk,jl) = 0._wp
-                  ENDIF
-               END DO
-            END DO
-         END DO
-         !
-         !-----------------------------------------------------
-         ! zap ice and snow volume, add water and salt to ocean
-         !-----------------------------------------------------
-         DO jj = 1 , jpj
-            DO ji = 1 , jpi
-              IF( pv_i(ji,jj,jl) < 0._wp ) THEN
-                  wfx_res(ji,jj)    = wfx_res(ji,jj) + pv_i (ji,jj,jl) * rhoi * r1_rdtice
-                  pv_i   (ji,jj,jl) = 0._wp
-               ENDIF
-               IF( pv_s(ji,jj,jl) < 0._wp ) THEN
-                  wfx_res(ji,jj)    = wfx_res(ji,jj) + pv_s (ji,jj,jl) * rhos * r1_rdtice
-                  pv_s   (ji,jj,jl) = 0._wp
-               ENDIF
-               IF( psv_i(ji,jj,jl) < 0._wp ) THEN
-                  sfx_res(ji,jj)    = sfx_res(ji,jj) + psv_i(ji,jj,jl) * rhoi * r1_rdtice
-                  psv_i  (ji,jj,jl) = 0._wp
-               ENDIF
-            END DO
-         END DO
-         !
-      END DO 
       !
    END SUBROUTINE ice_var_zapneg
Index: /NEMO/branches/2018/dev_r9947_SI3_advection/src/NST/agrif_oce.F90
===================================================================
--- /NEMO/branches/2018/dev_r9947_SI3_advection/src/NST/agrif_oce.F90	(revision 10410)
+++ /NEMO/branches/2018/dev_r9947_SI3_advection/src/NST/agrif_oce.F90	(revision 10411)
@@ -22,5 +22,5 @@
    !                                              !!* Namelist namagrif: AGRIF parameters
    LOGICAL , PUBLIC ::   ln_spc_dyn    = .FALSE.   !:
-   INTEGER , PUBLIC, PARAMETER ::   nn_sponge_len = 2  !: Sponge width (in number of parent grid points)
+   INTEGER , PUBLIC, PARAMETER ::   nn_sponge_len = 1  !: Sponge width (in number of parent grid points)
    REAL(wp), PUBLIC ::   rn_sponge_tra = 2800.     !: sponge coeff. for tracers
    REAL(wp), PUBLIC ::   rn_sponge_dyn = 2800.     !: sponge coeff. for dynamics
Index: /NEMO/branches/2018/dev_r9947_SI3_advection/tests/ICEADV/EXPREF/file_def_nemo-ice.xml
===================================================================
--- /NEMO/branches/2018/dev_r9947_SI3_advection/tests/ICEADV/EXPREF/file_def_nemo-ice.xml	(revision 10410)
+++ /NEMO/branches/2018/dev_r9947_SI3_advection/tests/ICEADV/EXPREF/file_def_nemo-ice.xml	(revision 10411)
@@ -21,4 +21,9 @@
         <field field_ref="snwvolu"          name="snvolu" />
         <field field_ref="icethic"          name="sithic" />
+        <field field_ref="icethic"          name="sithic_max" operation="maximum" />
+        <field field_ref="icethic"          name="sithic_min" operation="minimum" />
+        <field field_ref="iceneg_pres"      name="sineg_pres" />
+        <field field_ref="iceneg_volu"      name="sineg_volu" />
+        <field field_ref="fasticepres"      name="fasticepres" />
         <field field_ref="icevolu"          name="sivolu" />
         <field field_ref="iceconc"          name="siconc" />
@@ -29,50 +34,11 @@
         <field field_ref="sss_m"            name="sss_m"  />
 
-        <!-- heat -->
-        <field field_ref="icetemp"          name="sitemp" />
-        <field field_ref="icettop"          name="sittop" />
-        <field field_ref="icetbot"          name="sitbot" />
-        <field field_ref="icetsni"          name="sitsni" />
-
         <!-- momentum -->
         <field field_ref="uice"             name="sivelu"  />
         <field field_ref="vice"             name="sivelv"  />
         <field field_ref="icevel"           name="sivelo"  />
-        <field field_ref="utau_ai"          name="utau_ai" />
-        <field field_ref="vtau_ai"          name="vtau_ai" />
-        <field field_ref="utau_oi"          name="utau_oi" />
-        <field field_ref="vtau_oi"          name="vtau_oi" />
 
         <!-- rheology -->
         <field field_ref="icediv"           name="sidive"  />
-        <field field_ref="iceshe"           name="sishea"  />
-        <field field_ref="icestr"           name="sistre"  />
-        <field field_ref="normstr"          name="normstr" />
-        <field field_ref="sheastr"          name="sheastr" />
-        <field field_ref="isig1"            name="isig1"   />
-        <field field_ref="isig2"            name="isig2"   />
-        <field field_ref="isig3"            name="isig3"   />
-
-        <!-- heat fluxes -->
-        <field field_ref="qt_oce_ai"        name="qt_oce_ai"  />
-        <field field_ref="qt_atm_oi"        name="qt_atm_oi"  />
-        <field field_ref="qtr_ice_top"      name="qtr_ice_top"/>
-        <field field_ref="qtr_ice_bot"      name="qtr_ice_bot"/>
-        <field field_ref="qt_ice"           name="qt_ice"     />
-        <field field_ref="qsr_ice"          name="qsr_ice"    />
-        <field field_ref="qns_ice"          name="qns_ice"    />
-        <field field_ref="qemp_ice"         name="qemp_ice"   />
-        <field field_ref="albedo"           name="albedo"     />
-
-        <field field_ref="hfxcndtop"        name="hfxcndtop"  />
-        <field field_ref="hfxcndbot"        name="hfxcndbot"  />
-        <field field_ref="hfxsensib"        name="hfxsensib"  />
-
-        <!-- salt fluxes -->
-        <field field_ref="sfxice"           name="sfxice" />
-
-        <!-- mass fluxes -->
-        <field field_ref="vfxice"           name="vfxice" />
-        <field field_ref="vfxsnw"           name="vfxsnw" />
 
         <!-- categories -->
@@ -81,6 +47,4 @@
         <field field_ref="iceconc_cat"      name="siconcat"/>
         <field field_ref="icethic_cat"      name="sithicat"/>
-        <field field_ref="icesalt_cat"      name="sisalcat"/>
-        <field field_ref="icetemp_cat"      name="sitemcat"/>
 
         </file>
Index: /NEMO/branches/2018/dev_r9947_SI3_advection/tests/ICEDYN/EXPREF/1_namelist_ice_cfg
===================================================================
--- /NEMO/branches/2018/dev_r9947_SI3_advection/tests/ICEDYN/EXPREF/1_namelist_ice_cfg	(revision 10410)
+++ /NEMO/branches/2018/dev_r9947_SI3_advection/tests/ICEDYN/EXPREF/1_namelist_ice_cfg	(revision 10411)
@@ -1,4 +1,4 @@
 !!>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
-!! SI3 namelist:  
+!! SI3 configuration namelist: Overwrites SHARED/namelist_ice_ref
 !!              1 - Generic parameters                 (nampar)
 !!              2 - Ice thickness discretization       (namitd)
@@ -33,7 +33,8 @@
 &namdyn         !   Ice dynamics
 !------------------------------------------------------------------------------
-   ln_dynFULL       = .false.         !  dyn.: full ice dynamics               (rheology + advection + ridging/rafting + correction)
+   ln_dynALL        = .false.         !  dyn.: full ice dynamics               (rheology + advection + ridging/rafting + correction)
    ln_dynRHGADV     = .true.          !  dyn.: no ridge/raft & no corrections  (rheology + advection)
-   ln_dynADV        = .false.         !  dyn.: only advection w prescribed vel.(rn_uvice + advection)
+   ln_dynADV1D      = .false.         !  dyn.: only advection 1D                  (Schar & Smolarkiewicz 1996 test case)
+   ln_dynADV2D      = .false.         !  dyn.: only advection 2D w prescribed vel.(rn_uvice + advection)
       rn_uice       =   0.5           !        prescribed ice u-velocity
       rn_vice       =   0.            !        prescribed ice v-velocity
Index: /NEMO/branches/2018/dev_r9947_SI3_advection/tests/ICEDYN/EXPREF/file_def_nemo-ice.xml
===================================================================
--- /NEMO/branches/2018/dev_r9947_SI3_advection/tests/ICEDYN/EXPREF/file_def_nemo-ice.xml	(revision 10410)
+++ /NEMO/branches/2018/dev_r9947_SI3_advection/tests/ICEDYN/EXPREF/file_def_nemo-ice.xml	(revision 10411)
@@ -21,4 +21,9 @@
         <field field_ref="snwvolu"          name="snvolu" />
         <field field_ref="icethic"          name="sithic" />
+        <field field_ref="icethic"          name="sithic_max" operation="maximum" />
+        <field field_ref="icethic"          name="sithic_min" operation="minimum" />
+        <field field_ref="iceneg_pres"      name="sineg_pres" />
+        <field field_ref="iceneg_volu"      name="sineg_volu" />
+        <field field_ref="fasticepres"      name="fasticepres" />
         <field field_ref="icevolu"          name="sivolu" />
         <field field_ref="iceconc"          name="siconc" />